## svt-av1-dmo 4.0.0

=== CMakeLists.txt ===
#
# Copyright(c) 2018 Intel Corporation
#
# This source code is subject to the terms of the BSD 2 Clause License and
# the Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

cmake_minimum_required(VERSION 3.16...4.1)

if("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    message(WARNING "Building in-source is highly not recommended\n"
                    "Please use the Build folder or create your own.")
endif()

project(svt-av1 VERSION 4.0.0
    LANGUAGES C CXX)

set(VERSION_TAG "")

set(CMAKE_C_VISIBILITY_PRESET hidden)
# Default build type to release if the generator does not has its own set of build types
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE Release)
endif()

if(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message(WARNING "32-bit is not supported")
endif()

include(CheckCSourceCompiles)

check_c_source_compiles("
#if defined(_M_X64) || defined(__x86_64__)
#else
#error \"Non-x64\"
#endif
int main(void) {}
" HAVE_X86_PLATFORM)

check_c_source_compiles("
#if defined(__aarch64__) || defined(_M_ARM64)
#else
#error \"Non-arm64\"
#endif
int main(void) {}
" HAVE_ARM_PLATFORM)

option(COMPILE_C_ONLY "Compile only C code with no simds (autodetect, default off for x86)" OFF)
option(MINIMAL_BUILD "Enable minimal build" OFF)
if(MINIMAL_BUILD)
    add_definitions(-DMINIMAL_BUILD=1)
endif()

option(LOG_QUIET "Disable all logging from encoder" OFF)
if(LOG_QUIET)
    add_definitions(-DCONFIG_LOG_QUIET=1)
endif()

option(RTC_BUILD "Optimize build for RTC by disabling unused features and logging" OFF)
if(RTC_BUILD)
    add_definitions(-DRTC_BUILD=1)
endif()

if(NOT COMPILE_C_ONLY AND HAVE_X86_PLATFORM)
    include(CheckLanguage)
    check_language(ASM_NASM)
    if(CMAKE_ASM_NASM_COMPILER MATCHES "nasm")
        set(NASM_VERSION "0.0.0")
        execute_process(COMMAND ${CMAKE_ASM_NASM_COMPILER} -v
            OUTPUT_VARIABLE NASM_VERSION
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        string(REGEX MATCH "([.0-9])+" NASM_VERSION "${NASM_VERSION}")
        # NASM_VERSION should now contain something like 2.14.02
        # Needs to error out on a version less than 2.14
        if(NASM_VERSION VERSION_LESS "2.14")
            find_program(YASM_EXE yasm)
            if(YASM_EXE)
                set(CMAKE_ASM_NASM_COMPILER ${YASM_EXE})
                message(STATUS "Found nasm is too old (requires at least 2.14, found ${NASM_VERSION}), using yasm instead")
            else()
                message(FATAL_ERROR "Found nasm is too old (requires at least 2.14, found ${NASM_VERSION})!")
            endif()
        endif()
    endif()
    enable_language(ASM_NASM)
    add_definitions(-DARCH_X86_64=1)
elseif(NOT COMPILE_C_ONLY AND HAVE_ARM_PLATFORM)
    enable_language(ASM) # needed for .S files
    set(ARM64_FLAVORS "NEON;ARM_CRC32;NEON_DOTPROD;NEON_I8MM;SVE;SVE2")
    set(ARM_CRC32_DEFAULT_FLAG "-march=armv8-a+crc")
    set(NEON_DOTPROD_DEFAULT_FLAG "-march=armv8.2-a+dotprod")
    set(NEON_I8MM_DEFAULT_FLAG "-march=armv8.2-a+dotprod+i8mm")
    set(SVE_DEFAULT_FLAG "-march=armv8.2-a+dotprod+i8mm+sve")
    set(SVE2_DEFAULT_FLAG "-march=armv9-a+i8mm+sve2") # SVE2 is a v9-only feature

    option(ENABLE_NEON "Enables Neon optimizations on AArch64 targets." ON)
    option(ENABLE_ARM_CRC32 "Enables Arm CRC32 optimizations." ON)
    option(ENABLE_NEON_DOTPROD
      "Enables Armv8.2-A Neon DotProd optimizations on AArch64 targets." ON)
    option(ENABLE_NEON_I8MM
      "Enables Armv8.2-A Neon I8MM optimizations on AArch64 targets." ON)
    option(ENABLE_SVE "Enables Armv8.2-A SVE optimizations on AArch64 targets." ON)
    option(ENABLE_SVE2 "Enables Armv9-A SVE2 optimizations on AArch64 targets." ON)

    # Check that the compiler flag to enable each flavor is supported by the
    # compiler. This may not be the case for new architecture features on old
    # compiler versions.
    set(C_MAIN "\nint main(void) { return 0; }")
    foreach(flavor ${ARM64_FLAVORS})
        if(ENABLE_${flavor} AND NOT DEFINED ${flavor}_FLAG)
            set(${flavor}_FLAG "${${flavor}_DEFAULT_FLAG}")

            # Do not use check_c_compiler_flag here since the regex used to match
            # against stderr does not recognise the "invalid feature modifier" error
            # produced by certain versions of GCC, leading to the feature being
            # incorrectly marked as available.
            set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
            set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${${flavor}_FLAG}")
            unset(${flavor}_FLAG_SUPPORTED)
            check_c_source_compiles("static void function(void) {} ${C_MAIN}" ${flavor}_FLAG_SUPPORTED)
            set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})

            if(NOT ${flavor}_FLAG_SUPPORTED)
              set(ENABLE_${flavor} 0)
            endif()
        endif()
    endforeach()

    # SVE and SVE2 require that the Neon-SVE bridge header is also available.
    if(ENABLE_SVE OR ENABLE_SVE2)
        set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
        set(OLD_CMAKE_TRY_COMPILE_TARGET_TYPE ${CMAKE_TRY_COMPILE_TARGET_TYPE})
        set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${SVE_FLAG}")
        set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
        check_c_source_compiles("
#ifndef __ARM_NEON_SVE_BRIDGE
#error 1
#endif
#include <arm_sve.h>
#include <arm_neon_sve_bridge.h>" HAVE_SVE_HEADERS)
        # Check whether the compiler can compile SVE functions that require
        # backup/restore of SVE registers according to AAPCS. Clang for Windows used
        # to fail this, see https://github.com/llvm/llvm-project/issues/80009.
        check_c_source_compiles("
#include <arm_sve.h>
void other(void);
svfloat32_t func(svfloat32_t a) {
  other();
  return a;
} ${C_MAIN}" CAN_COMPILE_SVE)
        set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})
        set(CMAKE_TRY_COMPILE_TARGET_TYPE ${OLD_CMAKE_TRY_COMPILE_TARGET_TYPE})
        if(NOT HAVE_SVE_HEADERS OR NOT CAN_COMPILE_SVE)
            set(ENABLE_SVE 0)
            set(ENABLE_SVE2 0)
        endif()
    endif()

    foreach(flavor ${ARM64_FLAVORS})
        if(ENABLE_${flavor})
            add_compile_definitions(HAVE_${flavor}=1)
        else()
            add_compile_definitions(HAVE_${flavor}=0)
        endif()
    endforeach()

    add_definitions(-DARCH_AARCH64=1)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-lax-vector-conversions")
    # Prevents missmatch between arm and x86 bitstreams
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffp-contract=off")
endif()

include(GNUInstallDirs)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

# if(PROJECT_IS_TOP_LEVEL) requires CMake 3.21
if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    set(CMAKE_OUTPUT_DIRECTORY "${PROJECT_SOURCE_DIR}/Bin/${CMAKE_BUILD_TYPE}/" CACHE PATH "Location to write the resulting binaries to")

    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
endif()

set(PC_LIBS_PRIVATE)
set(PC_REQUIRES_PRIVATE)

#Clang support, required to build static with LTO
if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND UNIX AND NOT APPLE)
    find_program(LLVM_LD_EXE llvm-ld)
    find_program(LLVM_AR_EXE llvm-ar)
    find_program(LLVM_RANLIB_EXE llvm-ranlib)
    if(LLVM_LD_EXE)
        SET (CMAKE_LINKER  "llvm-ld")
    endif()
    if(LLVM_AR_EXE)
        SET (CMAKE_AR      "llvm-ar")
    endif()
    if(LLVM_RANLIB_EXE)
        SET (CMAKE_RANLIB  "llvm-ranlib")
    endif()
endif()

if(MSVC)
    if(DEFINED SANITIZER)
        message(WARNING "Sanitizers are not available with MSVC currently")
    endif()
    unset(SANITIZER)
    unset(SANITIZER CACHE)
else()
    set(SANITIZER "" CACHE STRING "Sanitizer to enable. Currently known values are Address, Memory, Thread, Undefined, and Integer")
    set_property(CACHE SANITIZER PROPERTY STRINGS Address Memory Thread Undefined Integer)
endif()

# Always build with -fPIC
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 11)

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
# make it prominent in the GUI.
option(BUILD_SHARED_LIBS "Build shared libraries (DLLs)." ON)
message(STATUS "BUILD_SHARED_LIBS: ${BUILD_SHARED_LIBS}")

option(BUILD_TESTING "Build SvtAv1UnitTests, SvtAv1ApiTests, and SvtAv1E2ETests unit tests")
option(COVERAGE "Generate coverage report")
if(NOT MSVC)
    option(SVT_AV1_PGO "Enable profile guided optimization. Creates the RunPGO and CompilePGO targets")
    # options for internal use
    option(SVT_INTERNAL_PGO_GENERATE "Generate a profile guided optimization profile")
    option(SVT_INTERNAL_PGO_USE "Use a profile for profile guided optimization")
    mark_as_advanced(SVT_INTERNAL_PGO_GENERATE SVT_INTERNAL_PGO_USE)
    set(SVT_AV1_PGO_DIR "${CMAKE_BINARY_DIR}" CACHE PATH "Path to the directory passed to -fprofile-dir for use with profile guided optimization")
    set(SVT_AV1_PGO_CUSTOM_VIDEOS "" CACHE STRING "Semi-colon separated list of directories with y4m videos to run PGO on instead of objective-1-fast")
else()
    set(SVT_AV1_PGO OFF)
endif()

if(MSVC AND SVT_AV1_PGO)
    message(WARNING "PGO is not yet supported for MSVC, disabling")
    unset(SVT_AV1_PGO)
    unset(SVT_AV1_PGO CACHE)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND SVT_AV1_PGO)
    find_program(LLVM_PROFDATA llvm-profdata)
    if(NOT LLVM_PROFDATA)
        message(FATAL_ERROR "llvm-profdata not found.")
    endif()
endif()

option(BUILD_APPS "Build Enc Apps" ON)
option(EXCLUDE_HASH "Disables the use of the git hash in the build to produce hash exact binaries, implies REPRODUCIBLE_BUILDS")
option(REPRODUCIBLE_BUILDS "Disable use of certain C macros to always generate reproducable builds" ${EXCLUDE_HASH})
if(SVT_AV1_PGO AND NOT BUILD_APPS)
    message(FATAL_ERROR "Can't use pgo and not build the apps")
endif()

if(SVT_INTERNAL_PGO_USE)
    if(MSVC)
        set(PGO_COMPILER_FLAGS "/GL")
        set(PGO_LINKER_FLAGS "/LTCG /USEPROFILE")
    else()
        set(PGO_COMPILER_FLAGS "-fprofile-use=${SVT_AV1_PGO_DIR}")
        set(PGO_LINKER_FLAGS "-fprofile-use=${SVT_AV1_PGO_DIR}")
        if (CMAKE_C_COMPILER_ID STREQUAL "GNU") # GCC
            # We want unprofiled code optimised for speed, not size, so we mark the profiling data as "partial".
            set(PGO_COMPILER_FLAGS "${PGO_COMPILER_FLAGS} -fprofile-correction -fprofile-partial-training")
            set(PGO_LINKER_FLAGS "${PGO_LINKER_FLAGS} -fprofile-correction -fprofile-partial-training")
        endif()
    endif()
elseif(SVT_INTERNAL_PGO_GENERATE)
    if(MSVC)
        set(PGO_COMPILER_FLAGS "/GL")
        set(PGO_LINKER_FLAGS "/LTCG /GENPROFILE")
    else()
        set(PGO_COMPILER_FLAGS "-fprofile-generate=${SVT_AV1_PGO_DIR}")
        set(PGO_LINKER_FLAGS "-fprofile-generate=${SVT_AV1_PGO_DIR}")
    endif()
endif()

if(SVT_AV1_PGO)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${PGO_COMPILER_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PGO_COMPILER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${PGO_LINKER_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${PGO_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${PGO_LINKER_FLAGS}")
endif()

if(EXCLUDE_HASH)
    add_link_options(-Wl,--build-id=none)
    add_definitions(-DEXCLUDE_HASH=1)
else()
    add_definitions(-DEXCLUDE_HASH=0)
endif()

if(REPRODUCIBLE_BUILDS)
    add_definitions(-DREPRODUCIBLE_BUILDS=1)
else()

=== Source/Lib/ASM_NEON_DOTPROD/CMakeLists.txt ===
#
# Copyright (c) 2024, Alliance for Open Media. All rights reserved
#
# This source code is subject to the terms of the BSD 2 Clause License and the
# Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License was
# not distributed with this source code in the LICENSE file, you can obtain it
# at www.aomedia.org/license/software. If the Alliance for Open Media Patent
# License 1.0 was not distributed with this source code in the PATENTS file, you
# can obtain it at www.aomedia.org/license/patent.
#

# ASM_NEON_DOTPROD Directory CMakeLists.txt

# Include Encoder Subdirectories

check_both_flags_add(-march=armv8.2-a+dotprod)

add_library(ASM_NEON_DOTPROD OBJECT)
target_sources(
  ASM_NEON_DOTPROD
  PUBLIC aom_convolve8_neon_dotprod.c
  PUBLIC cdef_neon_dotprod.c
  PUBLIC compute_sad_neon_dotprod.c
  PUBLIC convolve_neon_dotprod.c
  PUBLIC convolve_scale_neon_dotprod.c
  PUBLIC corner_match_neon_dotprod.c
  PUBLIC jnt_convolve_neon_dotprod.c
  PUBLIC pic_analysis_neon_dotprod.c
  PUBLIC sad_neon_dotprod.c
  PUBLIC sse_neon_dotprod.c
  PUBLIC variance_neon_dotprod.c)

target_include_directories(
  ASM_NEON_DOTPROD
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/API/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/)

=== Source/Lib/ASM_SVE2/CMakeLists.txt ===
#
# Copyright (c) 2024, Alliance for Open Media. All rights reserved
#
# This source code is subject to the terms of the BSD 2 Clause License and the
# Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License was
# not distributed with this source code in the LICENSE file, you can obtain it
# at www.aomedia.org/license/software. If the Alliance for Open Media Patent
# License 1.0 was not distributed with this source code in the PATENTS file, you
# can obtain it at www.aomedia.org/license/patent.
#

# ASM_SVE2 Directory CMakeLists.txt

# Include Encoder Subdirectories
add_library(ASM_SVE2 OBJECT)

check_both_flags_add(-march=armv9-a+i8mm+sve2)

target_sources(
  ASM_SVE2
  PUBLIC highbd_convolve_sve2.c
  PUBLIC highbd_jnt_convolve_sve2.c)

target_include_directories(
  ASM_SVE2
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/API/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE2/)

## svt-av1-dmo 1.2.1

=== debian/changelog ===
svt-av1-dmo (1.2.1-dmo0+deb11u1) stable; urgency=medium

  * Build for stable (Thanks to Radek Steiger for the bug report)

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 18 Oct 2022 15:56:02 +0200

svt-av1-dmo (1.2.1-dmo0~bpo11+1) stable-backports; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 21 Aug 2022 15:26:44 +0200

svt-av1-dmo (1.0.0-dmo0~bpo11+2) stable-backports; urgency=medium

  * libsvtav1-dev should be acrhitecture any

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 29 Apr 2022 15:51:18 +0200

svt-av1-dmo (1.0.0-dmo0~bpo11+1) stable-backports; urgency=medium

  * Build for stable-backports

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 29 Apr 2022 14:56:28 +0200

svt-av1-dmo (0.8.7-dmo2) unstable; urgency=medium

  * debian/control set Architecture: to any (was amd64 powerpc).

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 09 May 2021 08:57:55 +0200

svt-av1-dmo (0.8.7-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 09 May 2021 08:46:10 +0200

svt-av1-dmo (0.8.6-dmo3) unstable; urgency=medium

  * svt-av1 package should be in Section video
  * Changes upstream git address github --> gitlab

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 23 Mar 2021 11:06:16 +0100

svt-av1-dmo (0.8.6-dmo2) unstable; urgency=medium

  * Add powerpc to Architecture:

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 22 Mar 2021 14:10:51 +0100

svt-av1-dmo (0.8.6-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 29 Nov 2020 15:00:18 +0100

svt-av1-dmo (0.8.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 08 Sep 2020 08:36:46 +0200

svt-av1-dmo (0.8.4-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 29 Jun 2020 08:46:09 +0200

svt-av1-dmo (0.8.3-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 25 Apr 2020 08:38:59 +0200

svt-av1-dmo (0.8.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 20 Apr 2020 09:15:32 +0200

svt-av1-dmo (0.8.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 29 Jan 2020 13:36:41 +0100

svt-av1-dmo (0.8.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 21 Dec 2019 08:10:41 +0100

svt-av1-dmo (0.7.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 25 Nov 2019 08:37:02 +0100

svt-av1-dmo (0.7.0-dmo2) unstable; urgency=medium

  * Add nasm to build-depends

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 12 Oct 2019 08:24:47 +0200

svt-av1-dmo (0.7.0-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 28 Sep 2019 09:22:02 +0200

=== debian/control ===
Source: svt-av1-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://gitlab.com/AOMediaCodec/SVT-AV1
Standards-Version: 4.6.0
Build-Depends: debhelper-compat (= 13), nasm, cmake, ninja-build

Package: svt-av1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Scalable Video Technology for AV1 Encoder
 The Scalable Video Technology for AV1 Encoder (SVT-AV1 Encoder) is an
 AV1-compliant encoder library core. The SVT-AV1 development is a
 work-in-progress targeting performance levels applicable to both VOD and
 Live encoding / transcoding video applications.

Package: libsvtav1dec0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libsvtav1-0 (<= 1.0.0-dmo0~bpo11+1)
Description: Scalable Video Technology for AV1 (libsvtav1dec shared library)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an
 AV1-compliant encoder/decoder library core. The SVT-AV1 encoder
 development is a work-in-progress targeting performance levels applicable
 to both VOD and Live encoding / transcoding video applications. The
 SVT-AV1 decoder implementation is targeting future codec research
 activities.
 .
 This package provides the shared library libsvtav1dec.

Package: libsvtav1dec-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libsvtav1dec0 (= ${binary:Version}), ${misc:Depends}
Replaces: libsvtav1-dev (<= 1.0.0-dmo0~bpo11+1)
Description: Scalable Video Technology for AV1 (libsvtav1dec development files)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an
 AV1-compliant encoder/decoder library core. The SVT-AV1 encoder
 development is a work-in-progress targeting performance levels applicable
 to both VOD and Live encoding / transcoding video applications. The
 SVT-AV1 decoder implementation is targeting future codec research
 activities.
 .
 This package provides the development files for libsvtav1dec.

Package: libsvtav1enc1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Scalable Video Technology for AV1 (libsvtav1enc shared library)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an
 AV1-compliant encoder/decoder library core. The SVT-AV1 encoder
 development is a work-in-progress targeting performance levels applicable
 to both VOD and Live encoding / transcoding video applications. The
 SVT-AV1 decoder implementation is targeting future codec research
 activities.
 .
 This package provides the shared library libsvtav1enc.

Package: libsvtav1enc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libsvtav1enc1 (= ${binary:Version}), ${misc:Depends}
Replaces: libsvtav1-dev (<= 1.0.0-dmo0~bpo11+1)
Description: Scalable Video Technology for AV1 (libsvtav1enc development files)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an
 AV1-compliant encoder/decoder library core. The SVT-AV1 encoder
 development is a work-in-progress targeting performance levels applicable
 to both VOD and Live encoding / transcoding video applications. The
 SVT-AV1 decoder implementation is targeting future codec research
 activities.
 .
 This package provides the development files for libsvtav1enc.

Package: libsvtav1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsvtav1enc-dev (= ${binary:Version}), libsvtav1dec-dev (= ${binary:Version}), ${misc:Depends}
Replaces: libsvtav1enc-dev (<= 1.0.0-dmo0~bpo11+1), libsvtav1dec-dev (<= 1.0.0-dmo0~bpo11+1)
Description: Scalable Video Technology for AV1 Encoder - development files
 The Scalable Video Technology for AV1 Encoder (SVT-AV1 Encoder) is an
 AV1-compliant encoder library core. The SVT-AV1 development is a
 work-in-progress targeting performance levels applicable to both VOD and
 Live encoding / transcoding video applications.
 .
 This package contains the development files.

Package: libsvtav1-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: transitional dummy package
 This is a transitional dummy package, it can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

CONFIG_ARGS := -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DREPRODUCIBLE_BUILDS=ON

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq (i386,$(DEB_HOST_ARCH))
	CONFIG_ARGS += -DCOMPILE_C_ONLY=ON
endif

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- ${CONFIG_ARGS}

override_dh_clean:
	dh_clean Bin/None/*

override_dh_auto_test:

## svt-av1-dmo 1.5.0

=== debian/changelog ===
svt-av1-dmo (1:1.5.0-dmo1~bpo11+1) stable-backports; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 29 Apr 2023 10:10:36 +0200

svt-av1-dmo (1:1.4.1-dmo1~bpo11+1) stable-backports; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 16 Dec 2022 09:20:15 +0100

svt-av1-dmo (1:1.4.0-dmo0~bpo11+1) stable-backports; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 03 Dec 2022 08:32:54 +0100

svt-av1-dmo (1.3.0-dmo0~bpo11+1) stable-backports; urgency=medium

  * Build for stable-backports

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 29 Oct 2022 09:55:16 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://gitlab.com/AOMediaCodec/SVT-AV1
+Rules-Requires-Root: no
 Standards-Version: 4.6.0
-Build-Depends: debhelper-compat (= 13), nasm, cmake, ninja-build
+Build-Depends: debhelper-compat (= 13), cmake, ninja-build,
+ nasm [any-amd64 any-i386]
 
 Package: svt-av1
 Architecture: any

=== debian/watch ===
version=4

opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
https://gitlab.com/AOMediaCodec/SVT-AV1/-/tags \
.*/SVT-AV1-v(.*)@ARCHIVE_EXT@

## svt-av1-dmo 3.1.2

=== debian/changelog ===
svt-av1-dmo (2:3.1.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 25 Aug 2025 07:07:08 +0200

svt-av1-dmo (2:3.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 24 Aug 2025 08:14:18 +0200

svt-av1-dmo (2:3.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 28 Jul 2025 00:35:08 +0200

svt-av1-dmo (2:3.0.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 25 Mar 2025 08:42:01 +0100

svt-av1-dmo (2:3.0.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 11 Mar 2025 15:21:33 +0100

svt-av1-dmo (2:3.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 21 Feb 2025 00:12:14 +0100

svt-av1-dmo (2:2.3.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 29 Oct 2024 22:50:33 +0100

svt-av1-dmo (2:2.2.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 24 Aug 2024 09:29:04 +0200

svt-av1-dmo (2:2.2.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Aug 2024 07:54:43 +0200

svt-av1-dmo (2:2.1.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 29 Jun 2024 07:37:02 +0200

svt-av1-dmo (2:2.1.1-dmo2) unstable; urgency=medium

  * Remove libsvtav1-dev, libsvtav1dec0 and libsvtav1dec-dev as decoder has
    been removed.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 26 Jun 2024 11:07:03 +0200

svt-av1-dmo (2:2.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 26 Jun 2024 00:29:13 +0200

svt-av1-dmo (2:2.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 19 May 2024 01:00:46 +0200

svt-av1-dmo (2:2.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 14 Mar 2024 07:52:42 +0100

svt-av1-dmo (2:1.8.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 12 Dec 2023 07:43:45 +0100

svt-av1-dmo (2:1.7.0-dmo2) unstable; urgency=medium

  * Rename libsvtav1enc1 --> libsvtav1enc1d1

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 24 Sep 2023 11:56:05 +0200

svt-av1-dmo (2:1.7.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 25 Aug 2023 07:38:54 +0200

svt-av1-dmo (2:1.6.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 19 Jun 2023 09:02:52 +0200

svt-av1-dmo (2:1.5.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 27 Apr 2023 14:34:22 +0200

svt-av1-dmo (2:1.4.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 14 Dec 2022 08:36:40 +0100

svt-av1-dmo (2:1.4.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 01 Dec 2022 08:43:43 +0100

svt-av1-dmo (2:1.3.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 20 Oct 2022 09:22:33 +0200

svt-av1-dmo (2:1.2.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 17 Aug 2022 02:39:47 +0200

svt-av1-dmo (2:1.2.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 03 Aug 2022 07:09:58 +0200

svt-av1-dmo (2:1.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 18 May 2022 08:40:36 +0200

svt-av1-dmo (2:1.0.0-dmo4) unstable; urgency=medium

  * libsvtav1-dev should be acrhitecture any

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 29 Apr 2022 16:05:25 +0200

svt-av1-dmo (2:1.0.0-dmo3) unstable; urgency=medium

  * Add a transitional libsvtav1-0 package.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 29 Apr 2022 08:23:21 +0200

svt-av1-dmo (2:1.0.0-dmo2) unstable; urgency=medium

  * Fix replaces version.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 29 Apr 2022 08:04:28 +0200

svt-av1-dmo (2:1.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 29 Apr 2022 07:31:05 +0200

svt-av1-dmo (2:0.9.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 24 Feb 2022 08:37:24 +0100

svt-av1-dmo (2:0.9.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 22 Jan 2022 08:56:34 +0100

svt-av1-dmo (2:0.8.7-dmo3) unstable; urgency=medium

  * Add Conflicts with libsvtav1dec0, libsvtav1enc0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 16 Jan 2022 20:40:05 +0100

svt-av1-dmo (1:0.8.7-dmo2) unstable; urgency=medium

  * debian/control set Architecture: to any (was amd64 powerpc).

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 09 May 2021 08:57:55 +0200

=== debian/control ===
Source: svt-av1-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://gitlab.com/AOMediaCodec/SVT-AV1
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), cmake, ninja-build,
 nasm [any-amd64 any-i386], libcpuinfo-dev,

Package: svt-av1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Scalable Video Technology for AV1 Encoder
 The Scalable Video Technology for AV1 Encoder (SVT-AV1 Encoder) is an
 AV1-compliant encoder library core. The SVT-AV1 development is a
 work-in-progress targeting performance levels applicable to both VOD and
 Live encoding / transcoding video applications.

Package: libsvtav1enc3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Conflicts: libsvtav1enc1,
Replaces: libsvtav1enc1,
Description: Scalable Video Technology for AV1 (libsvtav1enc shared library)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an
 AV1-compliant encoder/decoder library core. The SVT-AV1 encoder
 development is a work-in-progress targeting performance levels applicable
 to both VOD and Live encoding / transcoding video applications. The
 SVT-AV1 decoder implementation is targeting future codec research
 activities.
 .
 This package provides the shared library libsvtav1enc.

Package: libsvtav1enc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libsvtav1enc3 (= ${binary:Version}), ${misc:Depends},
Replaces: libsvtav1-dev (<= 2:2.1.1-dmo1),
Description: Scalable Video Technology for AV1 (libsvtav1enc development files)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an
 AV1-compliant encoder/decoder library core. The SVT-AV1 encoder
 development is a work-in-progress targeting performance levels applicable
 to both VOD and Live encoding / transcoding video applications. The
 SVT-AV1 decoder implementation is targeting future codec research
 activities.
 .
 This package provides the development files for libsvtav1enc.

=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,11 @@
 	dh $@ -Scmake+ninja
 
 override_dh_auto_configure:
-	dh_auto_configure -- ${CONFIG_ARGS}
+	dh_auto_configure -- \
+	-DREPRODUCIBLE_BUILDS=1 \
+	${CONFIG_ARGS}
 
 override_dh_clean:
-	dh_clean Bin/None/*
+	dh_clean Bin/*/*
 
 override_dh_auto_test:

=== debian/watch ===
version=4

opts="searchmode=plain,dversionmangle=s/\+dfsg//g,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/" \
https://gitlab.com/AOMediaCodec/SVT-AV1/tags?sort=updated_desc \
-/archive/v?\d[\d.]+/SVT-AV1-@ANY_VERSION@@ARCHIVE_EXT@

## svt-av1-dmo 4.0.0

=== debian/changelog ===
svt-av1-dmo (2:4.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 24 Jan 2026 14:45:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: svt-av1-dmo
 Section: video
-Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://gitlab.com/AOMediaCodec/SVT-AV1
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Build-Depends: debhelper-compat (= 13), cmake, ninja-build,
  nasm [any-amd64 any-i386], libcpuinfo-dev,

## svt-av1-dmo 4.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
                     "Please use the Build folder or create your own.")
 endif()
 
-project(svt-av1 VERSION 4.0.0
+project(svt-av1 VERSION 4.0.1
     LANGUAGES C CXX)
 
 set(VERSION_TAG "")

=== Source/App/CMakeLists.txt ===
#
# Copyright(c) 2019 Intel Corporation
#
# This source code is subject to the terms of the BSD 2 Clause License and
# the Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

# APP Directory CMakeLists.txt

# Include Subdirectories
include_directories(${PROJECT_SOURCE_DIR}/Source/API/)

set(all_files
    ../API/EbConfigMacros.h
    ../API/EbDebugMacros.h
    ../API/EbSvtAv1.h
    ../API/EbSvtAv1Enc.h
    ../API/EbSvtAv1ErrorCodes.h
    ../API/EbSvtAv1Formats.h
    ../API/EbSvtAv1Metadata.h
    app_config.c
    app_config.h
    app_context.c
    app_context.h
    app_input_y4m.c
    app_input_y4m.h
    app_main.c
    app_output_ivf.c
    app_output_ivf.h
    app_process_cmd.c
    svt_time.c
    svt_time.h
    )

# App Source Files
add_executable(SvtAv1EncApp
    ${all_files})

if(TARGET safestringlib)
    target_sources(SvtAv1EncApp PRIVATE $<TARGET_OBJECTS:safestringlib>)
endif()

#********** SET COMPILE FLAGS************
# Link the Encoder App
target_link_libraries(SvtAv1EncApp PRIVATE SvtAv1Enc)

install(TARGETS SvtAv1EncApp RUNTIME COMPONENT Runtime DESTINATION ${CMAKE_INSTALL_BINDIR})

=== Source/Lib/CMakeLists.txt ===
#
# Copyright(c) 2019 Intel Corporation
#
# This source code is subject to the terms of the BSD 3 Clause Clear License and
# the Alliance for Open Media Patent License 1.0. If the BSD 3 Clause Clear License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

# Encoder Library directory CMakeLists.txt

add_library(common_lib INTERFACE)

if(COVERAGE)
    if(CMAKE_C_COMPILER_ID MATCHES "GNU")
        list(APPEND PC_LIBS_PRIVATE -lgcov)
    elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
        list(APPEND PC_LIBS_PRIVATE --coverage)
    endif()
endif()

include_directories(${PROJECT_SOURCE_DIR}/Source/API/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
    ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
    ${PROJECT_SOURCE_DIR}/third_party/fastfeat/)

add_library(SvtAv1Enc)
# Required for cmake to be able to tell Xcode how to link all of the object files
if(CMAKE_GENERATOR STREQUAL "Xcode")
    file(WRITE ${PROJECT_BINARY_DIR}/dummy.c "")
    target_sources(SvtAv1Enc PRIVATE ${PROJECT_BINARY_DIR}/dummy.c)
endif()

add_subdirectory(C_DEFAULT)
add_subdirectory(Codec)
add_subdirectory(Globals)
if(NOT COMPILE_C_ONLY AND HAVE_X86_PLATFORM)
    # Include Encoder Subdirectories
    target_include_directories(SvtAv1Enc PRIVATE
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE2/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSSE3/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE4_1/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX2/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX512/)
    add_subdirectory(ASM_SSE2)
    add_subdirectory(ASM_SSSE3)
    add_subdirectory(ASM_SSE4_1)
    add_subdirectory(ASM_AVX2)
    if(ENABLE_AVX512)
        add_subdirectory(ASM_AVX512)
    endif()
elseif(NOT COMPILE_C_ONLY AND HAVE_ARM_PLATFORM)
    target_include_directories(SvtAv1Enc PRIVATE
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON_DOTPROD/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON_I8MM/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE/
        ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE2/)
    add_subdirectory(ASM_NEON)
    if(ENABLE_NEON_DOTPROD)
        add_subdirectory(ASM_NEON_DOTPROD)
    endif()
    if(ENABLE_NEON_I8MM)
        add_subdirectory(ASM_NEON_I8MM)
    endif()
    if(ENABLE_SVE)
      add_subdirectory(ASM_SVE)
    endif()
    if(ENABLE_SVE2)
      add_subdirectory(ASM_SVE2)
    endif()
endif()

# Encoder Lib Source Files
target_sources(SvtAv1Enc PRIVATE
    $<TARGET_OBJECTS:FASTFEAT>
    $<TARGET_OBJECTS:GLOBALS>
    $<TARGET_OBJECTS:CODEC>
    $<TARGET_OBJECTS:C_DEFAULT>)
if(NOT COMPILE_C_ONLY AND HAVE_X86_PLATFORM)
    target_sources(SvtAv1Enc PRIVATE
        $<TARGET_OBJECTS:ASM_SSE2>
        $<TARGET_OBJECTS:ASM_SSSE3>
        $<TARGET_OBJECTS:ASM_SSE4_1>
        $<TARGET_OBJECTS:ASM_AVX2>)
    if(ENABLE_AVX512)
        target_sources(SvtAv1Enc PRIVATE
            $<TARGET_OBJECTS:ASM_AVX512>)
    endif()
elseif(NOT COMPILE_C_ONLY AND HAVE_ARM_PLATFORM)
    target_sources(SvtAv1Enc PRIVATE $<TARGET_OBJECTS:ASM_NEON>)
    if(ENABLE_NEON_DOTPROD)
        target_sources(SvtAv1Enc PRIVATE $<TARGET_OBJECTS:ASM_NEON_DOTPROD>)
    endif()
    if(ENABLE_NEON_I8MM)
        target_sources(SvtAv1Enc PRIVATE $<TARGET_OBJECTS:ASM_NEON_I8MM>)
    endif()
    if(ENABLE_SVE)
        target_sources(SvtAv1Enc PRIVATE $<TARGET_OBJECTS:ASM_SVE>)
    endif()
    if(ENABLE_SVE2)
        target_sources(SvtAv1Enc PRIVATE $<TARGET_OBJECTS:ASM_SVE2>)
    endif()
endif()

get_target_property(common_lib_source common_lib INTERFACE_SOURCES)
if(common_lib_source)
    target_sources(SvtAv1Enc PRIVATE ${common_lib_source})
endif()

if(BUILD_SHARED_LIBS)
    set(SVT_AV1_TARGET SVT-AV1-shared)
else()
    set(SVT_AV1_TARGET SVT-AV1-static)
endif()

set_target_properties(SvtAv1Enc PROPERTIES VERSION ${PROJECT_VERSION})
set_target_properties(SvtAv1Enc PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR})
set_target_properties(SvtAv1Enc PROPERTIES C_VISIBILITY_PRESET hidden)
set_target_properties(SvtAv1Enc PROPERTIES EXPORT_NAME ${SVT_AV1_TARGET})

target_link_libraries(SvtAv1Enc PUBLIC  "$<BUILD_INTERFACE:${PLATFORM_LIBS}>"
                                PRIVATE "$<INSTALL_INTERFACE:${PLATFORM_LIBS}>")

file(GLOB API_HEADERS ${PROJECT_SOURCE_DIR}/Source/API/*.h)
set_target_properties(SvtAv1Enc PROPERTIES PUBLIC_HEADER "${API_HEADERS}")

# Alias for the exported library target for use in subproject
add_library(SVT-AV1::SVT-AV1 ALIAS SvtAv1Enc)
add_library(SVT-AV1::${SVT_AV1_TARGET} ALIAS SvtAv1Enc)

set(ENC_PKG_CONFIG_EXTRA_CFLAGS "")
if (BUILD_SHARED_LIBS)
    target_compile_definitions(SvtAv1Enc
        PUBLIC EB_DLL
        PRIVATE EB_BUILDING_SHARED_LIBS)
    set(ENC_PKG_CONFIG_EXTRA_CFLAGS " -DEB_DLL")
endif()

if(RTC_BUILD)
    target_compile_definitions(SvtAv1Enc PUBLIC RTC_BUILD=1)
    set(ENC_PKG_CONFIG_EXTRA_CFLAGS "${ENC_PKG_CONFIG_EXTRA_CFLAGS} -DRTC_BUILD=1")
else()
    target_compile_definitions(SvtAv1Enc PUBLIC RTC_BUILD=0)
    set(ENC_PKG_CONFIG_EXTRA_CFLAGS "${ENC_PKG_CONFIG_EXTRA_CFLAGS} -DRTC_BUILD=0")
endif()

install(TARGETS SvtAv1Enc
        EXPORT ${SVT_AV1_TARGET}Targets
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
                COMPONENT Development
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
                COMPONENT Runtime
                NAMELINK_COMPONENT Development
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
                COMPONENT Runtime
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/svt-av1"
                COMPONENT Development
)

# pkg-config .pc file
list(JOIN PC_LIBS_PRIVATE " " LIBS_PRIVATE)
list(JOIN PC_REQUIRES_PRIVATE " " REQUIRES_PRIVATE)
configure_file(pkg-config.pc.in ${CMAKE_BINARY_DIR}/SvtAv1Enc.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/SvtAv1Enc.pc COMPONENT Development DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

# CMake config file
include(CMakePackageConfigHelpers)

target_include_directories(SvtAv1Enc INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/Source/API>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/svt-av1>)

configure_package_config_file(config.cmake.in SVT-AV1Config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/SVT-AV1
    PATH_VARS CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)

write_basic_package_version_file(SVT-AV1ConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion)

install(EXPORT ${SVT_AV1_TARGET}Targets
        NAMESPACE SVT-AV1::
        COMPONENT Development
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/SVT-AV1)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SVT-AV1Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/SVT-AV1ConfigVersion.cmake
        COMPONENT Development
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/SVT-AV1)

=== Source/Lib/ASM_AVX512/CMakeLists.txt ===
#
# Copyright(c) 2019 Intel Corporation
#
# This source code is subject to the terms of the BSD 2 Clause License and
# the Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

# Common/ASM_AVX512 Directory CMakeLists.txt

# Include Encoder Subdirectories
include_directories(${PROJECT_SOURCE_DIR}/Source/API/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
    ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE2/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSSE3/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE4_1/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX2/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX512/)

check_both_flags_add(
    -mavx2
    -mavx512f
    -mavx512bw
    -mavx512dq
    -mavx512vl)

if(MSVC)
    check_both_flags_add(/arch:AVX512)
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "Intel")
    if(WIN32)
        # Intel Windows (*Note - The Warning level /W0 should be made to /W4 at some point)
        check_both_flags_add(/Qdiag-disable:10010,10148,10157 /W0)
    else()
        check_both_flags_add(-static-intel -w)
    endif()
endif()

set(all_files
    cdef_avx512.c
    cdef_block_avx512.c
    compute_sad_intrin_avx512.c
    convolve_2d_avx512.c
    convolve_avx512.c
    convolve_avx512.h
    encodetxb_avx512.c
    highbd_fwd_txfm_AVX512.c
    highbd_intra_pred_avx512.c
    highbd_inv_txfm_avx512.c
    jnt_convolve_2d_avx512.c
    jnt_convolve_avx512.c
    pickrst_avx512.c
    pic_operators_intrin_avx512.c
    synonyms_avx512.h
    transpose_avx512.h
    transpose_encoder_avx512.h
    variance_avx512.c
    wiener_convolve_avx512.c
    )

add_library(ASM_AVX512 OBJECT ${all_files})

=== debian/changelog ===
svt-av1-dmo (2:4.0.1-dmo1~bpo13+1) trixie-backports; urgency=medium

  * Upload to trixie-backports

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 07 Feb 2026 09:07:22 +0100

svt-av1-dmo (2:4.0.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 29 Jan 2026 08:38:37 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  work-in-progress targeting performance levels applicable to both VOD and
  Live encoding / transcoding video applications.
 
-Package: libsvtav1enc3
+Package: libsvtav1enc4
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -37,7 +37,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libsvtav1enc3 (= ${binary:Version}), ${misc:Depends},
+Depends: libsvtav1enc4 (= ${binary:Version}), ${misc:Depends},
 Replaces: libsvtav1-dev (<= 2:2.1.1-dmo1),
 Description: Scalable Video Technology for AV1 (libsvtav1enc development files)
  The Scalable Video Technology for AV1 (SVT-AV1 Encoder and Decoder) is an

=== debian/watch ===
Version: 5

Template: GitLab
Dist: https://gitlab.com/AOMediaCodec/SVT-AV1/
